/***************************************************************************
 *   Copyright (C) 2008 by Oliver Groß   *
 *   z.o.gross@gmx.de   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifndef QFTRANSCCONNECTIONDIALOG_H
#define QFTRANSCCONNECTIONDIALOG_H

#include <QDialog>

class QLineEdit;
class QSpinBox;
class QLabel;

namespace qftrans {
	/**
		@author Oliver Groß <z.o.gross@gmx.de>
	*/
	class CConnectionDialog : public QDialog {
		Q_OBJECT
	public:
		CConnectionDialog(QWidget * parent = 0, Qt::WindowFlags f = 0);
		~CConnectionDialog();
		
		bool execute(bool isServer);
		
		QString host();
		quint16 port();
	private:
		QLabel * m_HostLabel;
		QLabel * m_PortLabel;
		QLineEdit * m_HostEdit;
		QSpinBox * m_PortEdit;
		
		inline void setupUi();
	private slots:
		void checkHost();
	};
}

#endif
