/***************************************************************************
 *   Copyright (C) 2008 by Oliver Groß   *
 *   z.o.gross@gmx.de   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifndef QFTRANS_CSENDERTHREAD_H
#define QFTRANS_CSENDERTHREAD_H

#include <QThread>
#include "common.h"

class QTcpSocket;

namespace qftrans {

	/**
		@author Oliver Groß <z.o.gross@gmx.de>
	*/
	class CSendThread : public QThread
	{
	Q_OBJECT
	public:
		CSendThread(QTcpSocket * socket, QObject * parent = 0);
		~CSendThread();
	signals:
		void uploadUpdated(TransferData * transfer);
	public slots:
		void addUpload(TransferData * transfer);
		void removeUpload(TransferData * transfer);
		void startUpload(TransferData * transfer);
		void startUploadData(quint32 id);
		
		void sendAcknowledge(quint32 id);
	protected slots:
		void writeData();
	protected:
		QTcpSocket * m_Socket;
		
		quint32 m_IdCounter;
		QTransferIdHash m_DataDict;
		
		void run();
	};

}

#endif
