/***************************************************************************
 *   Copyright (C) 2008 by Oliver Groß   *
 *   z.o.gross@gmx.de   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#include "ctransferthread.h"
#include "csocketmanager.h"
#include <QTcpServer>

namespace qftrans {
	CTransferThread::CTransferThread(QObject * parent) : QThread(parent),
		m_SocketManager(NULL) {
	}
	
	CTransferThread::~CTransferThread() {
		if (m_SocketManager)
			m_SocketManager->deleteLater();
/*		if (m_Socket)
			delete m_Socket;
		
		if (m_Worker)
			delete m_Worker;
		
		if (m_Server)
			delete m_Server;*/
	}
	
	void CTransferThread::run() {
		qDebug() << "start transfer thread" << currentThreadId();
		
		m_SocketManager = new CSocketManager();
		emit socketManagerReady();
		
		exec();
		
		qDebug() << "exit transfer thread" << currentThreadId();
		
		if (m_SocketManager) {
			delete m_SocketManager;
// 			m_SocketManager->deleteLater();
			m_SocketManager = NULL;
		}
		
/*		if (m_Worker) {
			delete m_Worker;
			m_Worker = NULL;
		}
		
		if (m_Server) {
			delete m_Server;
			m_Server = NULL;
		}
		
		if (m_Socket) {
			delete m_Socket;
			m_Socket = NULL;
		}*/
		
// 		emit connectionChanged(false);
	}
}
