/***************************************************************************
 *   Copyright (C) 2008 by Oliver Groß   *
 *   z.o.gross@gmx.de   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifndef QFTRANS_QTRANSFERLISTMODEL_H
#define QFTRANS_QTRANSFERLISTMODEL_H

#include <QAbstractListModel>
#include "common.h"

namespace qftrans {
	/**
		@author Oliver Groß <z.o.gross@gmx.de>
	*/
	class QTransferListModel : public QAbstractListModel {
		Q_OBJECT
	public:
		QTransferListModel(QTransferDataList * data, QObject * parent = 0);
		~QTransferListModel();
		
		int rowCount(const QModelIndex & parent = QModelIndex()) const;
		QVariant data(const QModelIndex & index, int role = Qt::DisplayRole) const;
		QModelIndex index (int row, int column = 0, const QModelIndex & parent = QModelIndex()) const;
	public slots:
		void updateEntry(TransferData * entry);
	private:
		QTransferDataList * m_Data;
	};
}

#endif
